# Monitoring Extension
This component represents the OCCI monitoring extension, we generated using [OCCI-Studio](https://github.com/occiware/OCCI-Studio).
The elements introduced in this extension mainly inherit from elements of the enhanced platform extension of [MoDMaCAO](https://github.com/occiware/MoDMaCAO),
as shown in the Figure below.

![Ext](./monExt.jpg "Ext")

## The Sensor Element
The sensor element represents a top level element used to easily manage all monitoring instruments it contains.
The containment relationship to its monitoring instruments is modeled via componentlinks.
As sensor inherits application, it gains access to attributes reflecting its current state, as well as actions to manage its lifecycle.
Thus, the monitoring instruments can be deployed by accessing the sensor directly, but also by addressing each instrument separately.

To specify the object a sensor monitors, it can be connected over a monitorableproperty to the corresponding resource.
The property itself defines two attributes defining the name of the property it monitors, and its results.

## The Monitoring Components
Each monitoring component (datagatherer, dataprocessor, resultprovider) inherit from component. 
Thus, each monitoring component gains access to actions to deploy, configure, start, stop, and undeploy it.
When not using the dummy connector, the execution of these actions trigger the execution of configuration management scripts linked to the individual monitoring instrument.
The name of the scripts are assigned over user mixins attached to the component, which is located in the roles folder of the MartServer.
To define where each monitoring instrument is deployed placementlinks are used connecting the instrument to the vm it is deployed on.
Thus, each instrument can be hosted by different vm.