# Initial Deployment Scenario
In this scenario a hadoop cluster with one worker node getting monitored is deployed.
This deployment serves as entry point for the other provided scenarios: [Vertical Scaling](./vertical.md), [Horizontal Scaling](./horizontal.md), and [Sensor Creation](./own.md).

## Starting the MartServer
To execute the scenario a MartServer has to be started including these [plugins](../src/test/resources/martserver-plugins).
If the getting started VM is used everything is preconfigured only requiring to start the following script.
Start a terminal and navigate to the desktop. The script can be started using the following command:
```
./startMART.sh
```
*Note:* If this scenario is not performed in a running cloud environment consider executing the resetMart.sh script first.

## Deploying the Cluster
Now the hadoop cluster can be deployed. Therefore, start the InitialDeployment.java file as an Java Application. This application performs requests to deploy the model shown below.
If the VM is used: Open a terminal and navigate to the VM's desktop and execute the initialDeployment.jar. 
```
java -jar initialDeployment.jar
```

After the deployment has been performed. The console running the MartServer puts out the simulated monitoring data in the following form:
```
INFO MonProp: CPU, set to: High(ba16f4ee-1601-4192-a259-eae4274aed72)
```
Moreover, you can investigate the deployed OCCI model by opening your browser and query for OCCI entitites:
```
http://localhost:8080/compute
http://localhost:8080/sensor
http://localhost:8080/monitorableproperty
```
The following figure visualized the initially deployed model:
![Init](./src/main/resources/de/ugoe/cs/rwm/mocci/occi/initial.jpg "Init")