# Sensor Creation
In this scenario the hadoop cluster model gets enhanced to monitor Memory utilization in addition to CPU utilization of worker nodes.

## Enhancing the Model for Simulation Purposes
The following description shows how to adapt the initial deployment model using an editor within OCCIWare Studio:

1. Start OCCIWare Studio.
2. Create a new Sirius Modeling Project
3. Copy the src/main/resources/hadoopClusterCPU.occic file from the MOCCI project into the new project
4. Open the file with the OCCI Model Editor
5. Expand the first item, as well as the Configuration it contains
6. Right click on Configuration->New Child->Resource
   1. Open the properties view and set the kind of the new resource to Sensor
   2. Right click on the Sensor to add a new link
      1. Set the kind of the link to Monitorableproperty
      2. Set the target of the link to the compute node it should monitor
      3. Add a new attribute to the Monitorableproperty link
          1. Name the attribute monitoring.property
          2. Set the value of the attribute to Mem
7. Add two new resources to the Configuration
    1. Set the kind of one resource to ResultProvider 
    2. Set the kind of the other resource to DataGatherer
8. Create two ComponentLink within the Sensor
     1. Link one to the ResultProvider
     2. Link the other to the DataGatherer
9. Save your changed

Even though the model currently does not of placementlinks required for an actual deployment, it is sufficient to perform the simulation.
To test the enhanced model follow the enumerated instructions:

1. Copy the enhanced model to the desktop
2. Open a terminal and navigate to the desktop
3. Start the Mart Server
4. Open another terminal and navigate to the desktop
5. Execute the following command
```
java -jar initialDeployment.jar hadoopClusterCPU.occic
```
This command puts your adjusted model into the models at runtime engine.
To start the added sensor execute the following REST request.
For example, curl can be used by starting another terminal.

```
curl -v -X POST http://localhost:8080/sensor/sensorid/?action=undeploy -H 'Content-Type: text/occi'  -H 'Category: undeploy; scheme="http://schemas.modmacao.org/occi/platform/application/action#"; class="action"' 
```

Finally, the added Sensors monitorable property should be filled with simulated monitoring data.
However, this time the simulated data corresponds to the ones that are simulated for Mem.
To adjust the simulation follow the instructions given in the tuning the scenario section of the [vertical scaling scenario](./vertical.md).


## Adjusting the Model for an actual deployment.
To make the model ready for an actual deployment placementlinks in each component of the sensor has to be added.
Moreover, the individual components have to be tagged with user mixins refering to their configuration management scripts.
Please refer to the [connector documentation](https://gitlab.gwdg.de/rwm/de.ugoe.cs.rwm.mocci/tree/master/de.ugoe.cs.rwm.mocci.connector) of the monitoring extension for more information.
The model for a concrete deployment of a memory monitoring sensor, including its configuration management script, can be found [here](../src/main/resources/hadoopClusterNewExtWithMem.occic).

## Visualizing the Model
To visualize the model the following steps can be performed.
In the sirius modeling project doubleclick on the representations.aird file and
double click on Configuration. It is recommended to collapse all elements and perform a reordering of them making the model more accessible.