# Vertical Scaling Scenario
Prerequisite for this scenario is the [initial deployment](./initial.md) of the hadoop cluster.
Thereafter, a MAPE-k loop is initialized that periodically checks whether the CPU utilization of the worker node reaches a critical level.
If that is the case a request against the OCCI API is performed, increasing the number of cores and memory available to the machine.

## Starting the Adaptation Script
In this scenario, a simple bash script is used to check the gathered monitoring data and perform corresponding actions.
This scenario serves as an example on how to directly work with the OCCI API, including the monitoring extension, by simply writing small bash scripts.
Before the adaptation script is started make sure that the MartServer is running and the hadoop cluster has been deployed.
To start the script execute the [vertical.sh](https://gitlab.gwdg.de/rwm/de.ugoe.cs.rwm.mocci/blob/master/src/main/resources/vertical.sh) script.
In the getting started VM the script is located on the desktop. Create a terminal navigate to the desktop and start the script with the following command:
```
./vertical.sh
```

When a critical cpu utilization is present in the model the monitored VM is upscaled from 2 to 8 cores.
Otherwise it is downscaled to 2 cores. The current amount of cores can be easiest checked by querying the compute node using a browser:
```
http://localhost:8080/compute/urn:uuid:2e6a73d0-faaa-476a-bd25-ca461dd166cf/
```

*Note:* This scenario mainly serves to get started with the OCCI API. Currently, there is no connector implementing the vertical adjustment as shown in this scenario.

## Tuning the Scenario
As the adaptation only upscales on a Critical behavior, it may be interesting to tune the simulated monitoring results.
Therefore, the following steps have to be performed:
1. Stop the MartServer (CTRL-C)
2. Navigate to ~/martserver-plugins
3. Open the de.ugoe.cs.rwm.mocci.connecter.dummy.jar with the archive manager.
4. Doubleclick on the resultprovider.properties file
5. Adjust the values to your liking

The file contains the following:
```
CPU = None,Low,Medium,High,Critical,5000
```
* CPU: Represents the monitorable.property to be adjusted.
* 5000: Represents the interval in which monitoring.results are written.
* None-Critical: Represents the simulated monitoring.results. 

*Note;* If you want to execute the second scenario please bring the resultprovider.properties file to its original state. 